String bytesToString(uint8_t *bytes, int nb) {
  String res = "";

  // transforme la longueur en chaine : 32 => "32"
  String nbStr = String(nb);
  // rajoute des zero avant : "32" => "032";
  int nbStrLen = nbStr.length();
  for (int jj = 0; jj < 3 - nbStrLen; jj++) nbStr = "0"+nbStr;
  // le met en premier:
  res += nbStr;

  // rajoute les bytes
  for (int i = 0; i < nb; i++) {
    uint8_t ci = bytes[i];
    if (ci < 255) ci = ci+1; // rajoute 1, pour ne pas avoir de caractère 0 (qui veut dire fin de chaine)
    res += (char)(ci);
  }
  return res;
}

void stringToBytes(String instr, uint8_t *bytes, int maxBytes, int* receivedBytes) {
  if (instr.length() < 4) return; // pas normal
  
  // prendre les 3 premiers caractères
  String nbString = instr.substring(0, 2);
  // convertir en nombre
  int nbBytes = instr.toInt();

  // prendre la chaine du 4 caractère jusque la fin
  instr = instr.substring(3);
  int nb = instr.length();
  int received = 0;
  for (int i = 0; i < nbBytes && i < maxBytes; i++) {
    char c = instr.charAt(i);
    uint8_t ci = (uint8_t)c - 1;
    bytes[i] = ci;
    received++;
  }

  // stocker le nombre recu
  *receivedBytes = received;
}
